# onion-grab of ct-sans (2023-04-03)

This directory contains the results of running `onion-grab` three times against
the [ct-sans dataset][] collected at 2023-04-03.  We used three VMs that exit in
Frankfurt, New York, and Melbourne using Mullvad VPN.  Our measurement setup and
operations timeline is documented separately in the `onion-grab` source repo.

[ct-sans dataset]: https://dart.cse.kau.se/ct-sans/2023-04-03-ct-sans.zip

Our measurements were conducted between 2023-04-03 and 2023-04-13, see:

  - [au-mel](./au-mel) (VM-1, Melbourne, Australia)
  - [us-nyc](./us-nyc) (VM-2, New York, USA)
  - [de-fra](./de-fra) (VM-3, Frankfurt, Germany)

Each subdirectory contains:

  - `onion-grab.stdout`: stdout output of the complete `onion-grab` run
  - `onion-grab.stderr`: stderr output of the complete `onion-grab` run
  - `measure.stderr`: stderr output of `scripts/measure.sh`
  - `sysctl.txt`: output of `sudo sysctl -a`
  - `ulimit.txt`: output of `ulimit -a`
  - `bw/`: hourly bandwidth dumps, one per day using `vnstat -h`

As outlined in the detailed timeline of operations, we had several issues with
VM-3.  We switched from Stockholm to Frankfurt due to performance issues.  All
output from the cancelled run are included herein, see [se-sto](./se-sto).

Further, `onion-grab` blew up on VM-3 due to too little memory twice.  While
this is easy to recover from by starting a new run that skips already processed
domain names, it resulted in three separate `*.stdout` and `*.stderr` files.
The output from the 2nd and 3rd runs end with `-{2,3}.{stdout,stderr}`.  Note
that there may be some overlap between the start and end of these traces, as we
wanted to make sure that no domains that configure Onion-Location are missed.

The raw results can be digested as follows:

    $ ./scripts/digest.py -i\
          au-mel/*.stdout\
          us-nyc/*.stdout\
          de-fra/*.stdout 2>&1 | tail -n4
    digest.py:27 INFO: found 26937 unqiue domain names that set Onion-Location
    digest.py:28 INFO: found 3330 unique two-label onion addresses in the process
    digest.py:30 INFO: storing domains with valid Onion-Location configurations in domains.txt
    digest.py:35 INFO: storing two-label onion addresses that domains referenced in onions.txt

The reason why there are so many more unique domains than onion addresses
appears to be caused by sites that copy HTML attributes without knowing their
meaning.  For example, 14k domains have the same Onion-Location as Twitter:

    $ cat onions.txt |\
          grep twitter3e4tixl4xyajtrzo62zg5vztmjuricljdp2c5kshju4avyoid.onion|\
          cut -d' ' -f2- |\
          wc -w
    13956

The parsed `domain.txt` and `onion.txt` files are included for convenience.
